#region Copyright Syncfusion Inc. 2001 - 2006
//
//  Copyright Syncfusion Inc. 2001 - 2006. All rights reserved.
//
//  Use of this code is subject to the terms of our license.
//  A copy of the current license can be obtained at any time by e-mailing
//  licensing@syncfusion.com. Any infringement will be prosecuted under
//  applicable laws. 
//
#endregion

using System;
using System.Collections;
using System.ComponentModel;

namespace ListItemReference
{

    /// <summary>
    ///		A strongly-typed collection of <see cref="Country_"/> objects.
    /// </summary>
    [Serializable]
    public class CountriesCollection_ : ArrayList
    {
        public new Country_ this[int index]
        {
            get
            {
                return (Country_)base[index];
            }
            set
            {
                base[index] = value;
            }
        }

        public static CountriesCollection_ CreateDefaultCollection()
        {
            CountriesCollection_ countries = new CountriesCollection_();
            countries.Add(new Country_("United States"));
            countries.Add(new Country_("Canada"));
            countries.Add(new Country_("Afghanistan"));
            countries.Add(new Country_("Albania"));
            countries.Add(new Country_("Algeria"));
            countries.Add(new Country_("American Samoa"));
            countries.Add(new Country_("Andorra"));
            countries.Add(new Country_("Angola"));
            countries.Add(new Country_("Anguilla"));

            return countries;
        }

        public override bool IsReadOnly
        {
            get
            {
                return false;
            }
        }

        public override bool IsFixedSize
        {
            get
            {
                return false;
            }
        }

    }


    [Serializable]
    public class Country_
    {
        private string _name;

        public Country_()
        {
        }

        public Country_(string strName)
        {
            this._name = strName;
        }

        [Browsable(true)]
        public string Name
        {

            get
            {
                return _name;
            }
            set
            {
                _name = value;
            }
        }

        //public override string ToString()
        //{
        //    return this._name + "(" + this._code + ")";
        //}
    }
}
