#region Copyright Syncfusion Inc. 2001 - 2006
//
//  Copyright Syncfusion Inc. 2001 - 2006. All rights reserved.
//
//  Use of this code is subject to the terms of our license.
//  A copy of the current license can be obtained at any time by e-mailing
//  licensing@syncfusion.com. Any infringement will be prosecuted under
//  applicable laws. 
//
#endregion

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

using Syncfusion.Grouping;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;

namespace ListItemReference
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
        private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridGroupingControl1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			try
			{
				Icon ico = new Icon(Syncfusion.Windows.Forms.WinFormsUtils.FindFile("Icon", "sfgrid.ico"));
				this.Icon = ico ;	
			}
			catch
			{}

			USStatesCollection usStates = USStatesCollection.CreateDefaultCollection();
			CountriesCollection_ countries = CountriesCollection_.CreateDefaultCollection();

			this.gridGroupingControl1.Engine.SourceListSet.Add("Countries", countries);
			this.gridGroupingControl1.Engine.SourceListSet.Add("USStates", usStates);

			DataTable table = new DataTable();
			table.Columns.Add("Id", typeof(string));
			table.Columns.Add("Country", typeof(Country_));
			table.Columns.Add("State", typeof(USState));
           

			// and then add a few rows:
			for ( int i=0; i < 50; i++ )
			{
				table.Rows.Add(table.NewRow());
				table.Rows[i][0] = i%5;
				table.Rows[i][1] = countries[i%8];
				if (i%8 == 0)
					table.Rows[i][2] = usStates[i/8];
			}

			GridTableDescriptor mainTd = this.gridGroupingControl1.TableDescriptor;
			//mainTd.Fields.ExpandProperties = false;
			//mainTd.TableOptions.AllowForeignKeyDropDown = false;

			GridRelationDescriptor usStatesRd = new GridRelationDescriptor();
			usStatesRd.Name = "State";
			usStatesRd.MappingName = "State";  // FieldName in table
			usStatesRd.ChildTableName = "USStates";  // SourceListSet name for lookup
			usStatesRd.RelationKind = RelationKind.ListItemReference;
			usStatesRd.ChildTableDescriptor.Appearance.AlternateRecordFieldCell.BackColor = Color.Beige;
			usStatesRd.ChildTableDescriptor.VisibleColumns.Add("Name");
			usStatesRd.ChildTableDescriptor.SortedColumns.Add("Name");
			//usStatesRd.ChildTableDescriptor.AllowEdit = false;
			//usStatesRd.ChildTableDescriptor.AllowNew = false;  // Make pencil icon disappear, users can't modify states.
			mainTd.Relations.Add(usStatesRd);

			GridRelationDescriptor countriesRd = new GridRelationDescriptor();
			countriesRd.Name = "Country";
			countriesRd.MappingName = "Country";  // FieldName in table
			countriesRd.ChildTableName = "Countries";  // SourceListSet name for lookup
			countriesRd.RelationKind = RelationKind.ListItemReference;
			countriesRd.ChildTableDescriptor.Appearance.AlternateRecordFieldCell.BackColor = Color.Beige;
			countriesRd.ChildTableDescriptor.AllowEdit = true;
			countriesRd.ChildTableDescriptor.AllowNew = true;  // Make pencil icon appear, allow user to add countries (these setting will be overriden by CountriesCollection.IsReadOnly / CountriesCollection.IsFixedSize properties if they are true).
			mainTd.Relations.Add(countriesRd);

//			mainTd.Columns.Add("Id");
//			mainTd.Columns.Add(new GridColumnDescriptor("Country", "Country.CountryCode", "Country"));
//			mainTd.Columns.Add(new GridColumnDescriptor("Country.Name"));
//			mainTd.Columns.Add(new GridColumnDescriptor("US State", "State.Name"));
//
//
//			mainTd.Columns["Country"].Width = 50;
//			mainTd.Columns["Country.Name"].Width = 200;
//			mainTd.Columns["US State"].Width = 200;

			this.gridGroupingControl1.DataSource = table;

            this.gridGroupingControl1.TableDescriptor.GroupedColumns.Add("Id");


			// After data source was set you could call LoadDefault and remove columns
			//			mainTd.Columns.LoadDefault();
			//			mainTd.Columns.Remove("Country.CountryCode");

		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.gridGroupingControl1 = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
            ((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).BeginInit();
            this.SuspendLayout();
            // 
            // gridGroupingControl1
            // 
            this.gridGroupingControl1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
                        | System.Windows.Forms.AnchorStyles.Left)
                        | System.Windows.Forms.AnchorStyles.Right)));
            this.gridGroupingControl1.BackColor = System.Drawing.SystemColors.Window;
            this.gridGroupingControl1.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
            this.gridGroupingControl1.IntelliMousePanning = true;
            this.gridGroupingControl1.Location = new System.Drawing.Point(12, 40);
            this.gridGroupingControl1.Name = "gridGroupingControl1";
            this.gridGroupingControl1.ShowGroupDropArea = true;
            this.gridGroupingControl1.Size = new System.Drawing.Size(715, 392);
            this.gridGroupingControl1.TabIndex = 0;
            this.gridGroupingControl1.Text = "gridGroupingControl1";
            // 
            // Form1
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(747, 422);
            this.Controls.Add(this.gridGroupingControl1);
            this.Name = "Form1";
            this.Text = "List Item Reference";
            ((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).EndInit();
            this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{

            # if SyncfusionFramework1_1 || SyncfusionFramework2_0
                Application.EnableVisualStyles();
            # endif

			Application.Run(new Form1());
		}
	}
}
